package src.DrawningObjects;

import java.awt.*;
import java.util.Random;
import src.DirectionType;
import src.MovementStrategy.DrawningObjectAirplane;
import src.MovementStrategy.IMoveableObject;
import src.Entities.EntityAirplane;
public class DrawningAirplane {

    protected EntityAirplane EntityAirplane;
    public int _pictureWidth;
    public int _pictureHeight;
    protected int _startPosX = 0;
    protected int _startPosY = 0;
    private int _airplaneWidth = 160;
    private int _airplaneHeight = 160;
    private int _airplanekorpusHeight = 90;
    protected IDraw DrawningEngines;

    public EntityAirplane EntityAirplane(){
        return EntityAirplane;
    }
    public DrawningAirplane(int speed, double weight, Color bodyColor, int width, int height){
        if(width <= _airplaneWidth || height <= _airplaneHeight)
            return;
        _startPosY=70;
        _startPosX = 0;
        _pictureWidth = width;
        _pictureHeight = height;
        EntityAirplane = new EntityAirplane(speed, weight, bodyColor);
        DrawningEngines = new DrawningEngines(_airplaneWidth, _airplaneHeight,_startPosX,_startPosY);
        Random rand = new Random();
        int variant = rand.nextInt(0,3);
        if(variant ==0){
            DrawningEngines = new DrawningEngines(_airplaneWidth, _airplaneHeight,_startPosX,_startPosY);
        } else{
            if(variant ==1){
                DrawningEngines = new DrawningEnginesQuad(_airplaneWidth, _airplaneHeight,_startPosX,_startPosY);

            }
            else if(variant==2) {
                DrawningEngines = new DrawningEnginesOval(_airplaneWidth, _airplaneHeight, _startPosX, _startPosY);
            }
            }
        DrawningEngines.ChangeEnginesNumb(rand.nextInt(1, 5));
    }

    public void SetPosition(int x, int y){
        if(EntityAirplane == null)
            return;
        _startPosX = x;
        _startPosY = y;
        DrawningEngines.ChangeX(_startPosX);
        DrawningEngines.ChangeY(_startPosY);
        if (x + _airplaneWidth >= _pictureWidth || y + _airplaneHeight >= _pictureHeight) {
            _startPosX = 0;
            _startPosY = 70;
        }
    }
    public int GetPosX(){return _startPosX;}
    public int GetPosY(){return _startPosY;}
    public int GetWidth(){return _airplaneWidth;}
    public int GetHeight(){return _airplaneHeight;}
    public boolean CanMove(DirectionType direction)
    {
        if (EntityAirplane == null)
            return false;
        boolean can = false;
        switch (direction)
        {
            case Left:
                can = _startPosX - EntityAirplane.Step() >= 0;
                break;
            case Right:
                can = _startPosX + EntityAirplane.Step() + _airplaneWidth< _pictureWidth;
                break;
            case Down:
                can = _startPosY + EntityAirplane.Step() + _airplanekorpusHeight < _pictureHeight;
                break;
            case Up:
                can = _startPosY - EntityAirplane.Step() - _airplaneHeight >= 0;
                break;
        };
        return can;
    }
    public IMoveableObject GetMoveableObject(){
        return new DrawningObjectAirplane(this);
    }
    public void MoveTransport(DirectionType direction){
        if (!CanMove(direction) || EntityAirplane == null)
            return;
        switch (direction)
        {
            case Left:
                if (_startPosX - EntityAirplane.Step() >= 0)
                    _startPosX -= (int)EntityAirplane.Step();
                else
                    _startPosX = 0;
                break;
            case Up:
                if (_startPosY - EntityAirplane.Step() - _airplaneHeight >= 0)
                    _startPosY -= (int)EntityAirplane.Step();
                else
                    _startPosY = 0;
                break;
            case Right:
                if (_startPosX + EntityAirplane.Step() + _airplaneWidth < _pictureWidth)
                    _startPosX += (int)EntityAirplane.Step();
                else
                    _startPosX = _pictureWidth - _airplaneWidth;
                break;
            case Down:
                if (_startPosY + EntityAirplane.Step() + _airplaneHeight < _pictureHeight)
                    _startPosY += (int)EntityAirplane.Step();
                else
                    _startPosY = _pictureHeight - _airplaneHeight;
                break;
        }
        DrawningEngines.ChangeX(_startPosX);
        DrawningEngines.ChangeY(_startPosY);
    }
    public void DrawAirplane(Graphics2D g2d){

        if (EntityAirplane == null)
            return;
        DrawningEngines.DrawEngines(g2d);
//тело самолёта
        g2d.setColor(EntityAirplane.BodyColor());
        g2d.fillRect(_startPosX + 20,_startPosY +4,140,20);
        g2d.setColor(Color.BLACK);
        g2d.drawRect(_startPosX + 20,_startPosY +4,140,20);
//Нос самолёта
        int[] xPointsArrNose = {_startPosX + 20,_startPosX + 20,_startPosX-3};
        int[] yPointsArrNose = {_startPosY + 4,_startPosY + 24,_startPosY + 12};
        g2d.setColor(Color.BLACK);
        g2d.fillPolygon(xPointsArrNose, yPointsArrNose, xPointsArrNose.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(xPointsArrNose, yPointsArrNose, xPointsArrNose.length);

// Правое крыло
        int[] xPointsArrRightWing = {_startPosX + 80,_startPosX+80,_startPosX+85,_startPosX + 100};
        int[] yPointsArrRightWing = { _startPosY + 4,_startPosY - 66,_startPosY - 66, _startPosY + 4  };
        g2d.setColor(EntityAirplane.BodyColor());
        g2d.fillPolygon(xPointsArrRightWing, yPointsArrRightWing, xPointsArrRightWing.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(xPointsArrRightWing, yPointsArrRightWing, xPointsArrRightWing.length);

// Левое крыло
        int[] xPointsArrLeftWing = {_startPosX + 80,_startPosX + 100,_startPosX+85,_startPosX+80};
        int[] yPointsArrLeftWing = {_startPosY + 24,_startPosY + 24,_startPosY + 94,_startPosY + 94};
        g2d.setColor(EntityAirplane.BodyColor());
        g2d.fillPolygon(xPointsArrLeftWing, yPointsArrLeftWing, xPointsArrLeftWing.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(xPointsArrLeftWing, yPointsArrLeftWing, xPointsArrLeftWing.length);

// Правое задние крыло
        int[] xPointsArrRightBackWing={_startPosX + 140,_startPosX + 160,_startPosX+160,_startPosX+140};
        int[] yPointsArrRightBackWing={ _startPosY + 4,_startPosY + 4,_startPosY - 22,_startPosY -4};
        g2d.setColor(EntityAirplane.BodyColor());
        g2d.fillPolygon(xPointsArrRightBackWing, yPointsArrRightBackWing, xPointsArrRightBackWing.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(xPointsArrRightBackWing, yPointsArrRightBackWing, xPointsArrRightBackWing.length);
// Заднее левое крыло
        int[] xPointsArrLeftBackWing= {_startPosX + 140,_startPosX + 160,_startPosX+160,_startPosX+140};
        int[] yPointsArrLeftBackWing= {_startPosY + 24,_startPosY + 24,_startPosY + 50,_startPosY + 32};
        g2d.setColor(EntityAirplane.BodyColor());
        g2d.fillPolygon(xPointsArrLeftBackWing, yPointsArrLeftBackWing, xPointsArrLeftBackWing.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(xPointsArrLeftBackWing, yPointsArrLeftBackWing, xPointsArrLeftBackWing.length);



    }


}
