package src;

import src.DrawningObjects.DrawningAirplane;
import src.Generics.AirplaneGenericCollection;
import src.FormAirFighter;
import src.MovementStrategy.DrawningObjectAirplane;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class FormAirFighterCollection {
    private final AirplaneGenericCollection<DrawningAirplane, DrawningObjectAirplane> _airplanes;
    private int pictureBoxWidth = 902;
    private int pictureBoxHeight = 453;

    CollectionCanvas canv;

    void Draw(){
        if(canv == null)
            return;
        canv.repaint();
    }

    public FormAirFighterCollection(){
        _airplanes = new AirplaneGenericCollection<>(pictureBoxWidth, pictureBoxHeight);
        canv = new CollectionCanvas();
        JPanel toolBox = new JPanel();
        JFrame collectionFrame = new JFrame();
        collectionFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        collectionFrame.setSize(880,497);
        toolBox.setBounds(666, 12, 127, 426);
        canv.setBounds(12,12,pictureBoxWidth,pictureBoxHeight);
        JButton addButton = new JButton("Добавить");
        JButton removeButton = new JButton("Удалить");
        JButton refreshButton = new JButton("Обновить");
        JTextField airplaneNumb = new JTextField();
        GridLayout lay = new GridLayout(4,1);
        toolBox.setLayout(lay);
        toolBox.add(addButton);
        toolBox.add(airplaneNumb);
        toolBox.add(removeButton);
        toolBox.add(refreshButton);
        collectionFrame.add(toolBox);
        collectionFrame.add(canv);
        collectionFrame.setVisible(true);

        addButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_airplanes == null) {
                    return;
                }
                FormAirFighter form = new FormAirFighter();
                form.buttonSelect.addActionListener(new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        if (_airplanes.Insert(form.SelectedAirplane()) != -1)
                        {
                            JOptionPane.showMessageDialog(null, "Объект добавлен", "Информация", JOptionPane.INFORMATION_MESSAGE);
                            form.SelectedAirplane()._pictureWidth = pictureBoxWidth;
                            form.SelectedAirplane()._pictureHeight = pictureBoxHeight;
                            Draw();
                        }
                        else
                        {
                            JOptionPane.showMessageDialog(null, "Не удалось добавить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        }
                        canv._airplanes = _airplanes;
                        form.AirplaneFrame.dispose();
                        Draw();
                    }
                });
            }
        });
        removeButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_airplanes == null) {
                    return;
                }
                String tmp = airplaneNumb.getText();
                int numb;

                try{
                    numb = Integer.parseInt(tmp);
                }
                catch(Exception ex){
                    JOptionPane.showMessageDialog(null, "Введите число", "Информация", JOptionPane.INFORMATION_MESSAGE);
                    return;
                }
                _airplanes.Remove(numb);
                _airplanes.ShowAirplanes();
                JOptionPane.showMessageDialog(null, "Объект удален", "Информация", JOptionPane.INFORMATION_MESSAGE);
                Draw();
            }
        });

        refreshButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_airplanes == null) {
                    return;
                }
                _airplanes.ShowAirplanes();

                Draw();
            }
        });
    }
}

class CollectionCanvas extends JComponent {
    public AirplaneGenericCollection<DrawningAirplane, DrawningObjectAirplane> _airplanes;

    public CollectionCanvas(){
    }
    @Override
    public void paintComponent (Graphics g){
        if (_airplanes == null){
            return;
        }
        super.paintComponents (g) ;
        Graphics2D g2d = (Graphics2D)g;
        g2d.drawImage(_airplanes.ShowAirplanes(), 0, 0, this);
        super.repaint();
    }
}
