package src.Generics;

import src.DrawningObjects.DrawningAirplane;
import src.DrawningObjects.IDraw;
import src.Entities.EntityAirplane;

import java.util.Random;

public class HardGeneric <T extends EntityAirplane,U extends IDraw>{
    T[] arrFirst;
    U[] arrSecond;

    private int curSz;
    private int CountFirst;
    private int CountSecond;

    private int pictureBoxWidth;

    private int pictureBoxHeight;

    public HardGeneric(int countFirst, int countSecond, int width, int height){
        curSz = 0;
        CountFirst = countFirst;
        CountSecond = countSecond;
        arrFirst = (T[]) new EntityAirplane[CountFirst];
        arrSecond = (U[]) new IDraw[CountSecond];
        pictureBoxHeight = height;
        pictureBoxWidth = width;
    }

    public int InsertFirst(T entityAirplane){
        if(arrFirst[CountFirst-1] != null)
            return -1;
        for(int i = curSz -1; i>= 0; i--) {
            arrFirst[i + 1] = arrFirst[i];
            arrSecond[i + 1] = arrSecond[i];
        }
        curSz++;
        arrFirst[0] = entityAirplane;

        return 0;
    }

    public int InsertSecond(U inter){
        if(arrSecond[CountSecond-1] != null)
            return -1;
        arrSecond[0] = inter;
        return 0;
    }

    public DrawningAirplane MakeObject(){
        Random rand = new Random();
        int indFirst = rand.nextInt(0, curSz);
        int indSecond = rand.nextInt(0,curSz);
        EntityAirplane entity = arrFirst[indFirst];
        IDraw inter = arrSecond[indSecond];
        DrawningAirplane airplane = new DrawningAirplane(entity.Speed(), entity.Weight(), entity.BodyColor(),
                pictureBoxWidth, pictureBoxHeight);
        return airplane;
    }
}

