package src;

import src.DrawningObjects.DrawningAirplane;
import src.DrawningObjects.DrawningEngines;
import src.DrawningObjects.IDraw;
import src.Entities.EntityAirplane;
import src.Generics.HardGeneric;

import javax.swing.*;
import javax.swing.text.html.parser.Entity;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

public class HardForm {
    private Canvas canv;

    private int pictureBoxWidth;
    private int pictureBoxHeight;

    private EntityAirplane makeEntity(){
        Random rand = new Random();
        return new EntityAirplane(rand.nextInt(100, 300), rand.nextDouble(1000,3000),
                Color.getHSBColor(rand.nextInt(0, 301), rand.nextInt(0, 301), rand.nextInt(0, 301)));
    }
    void Draw(){
        if(canv == null)
            return;
        canv.repaint();
    }
    private IDraw makeIDraw(EntityAirplane entity){
        Random rand = new Random();
        return new DrawningEngines(pictureBoxWidth, pictureBoxHeight, 0, 0);
    }
    public HardForm(){
        Random rand = new Random();
        int sz = rand.nextInt(1, 10);

        JFrame HardFrame = new JFrame();
        HardFrame.setSize(700, 400);
        HardFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        canv = new Canvas();
        canv.setBounds(0,0,pictureBoxWidth,pictureBoxHeight);
        JButton makeObject = new JButton("Создать");
        makeObject.setBounds(0, 0, 100, 40);
        canv.add(makeObject);
        HardFrame.setContentPane(canv);
        HardFrame.setVisible(true);
        pictureBoxHeight = canv.getHeight();
        pictureBoxWidth = canv.getWidth();
        HardGeneric<EntityAirplane, IDraw> toDraw= new HardGeneric<>(sz,
                sz, pictureBoxWidth, pictureBoxHeight);
        for(int i = 0; i < sz; i++){
            EntityAirplane ent = makeEntity();
            toDraw.InsertFirst(ent);
            toDraw.InsertSecond(makeIDraw(ent));
        }
        makeObject.addActionListener(
                new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        DrawningAirplane DrawningAirplane = toDraw.MakeObject();
                        DrawningAirplane.SetPosition(pictureBoxWidth / 2 - DrawningAirplane.GetWidth()/2,
                                pictureBoxHeight / 2 - DrawningAirplane.GetHeight()/2);
                        canv.DrawningAirplane = DrawningAirplane;
                        Draw();
                    }
                }
        );

    }
}


