package src.MovementStrategy;
import src.DirectionType;
import src.DrawningObjects.DrawningAirplane;

public class DrawningObjectAirplane implements IMoveableObject{
    private final DrawningAirplane _drawningAirplane;
    public DrawningObjectAirplane(DrawningAirplane drawningAirplane){
        _drawningAirplane = drawningAirplane;
    }
    public ObjectParameters GetObjectParameters(){
        if(_drawningAirplane == null || _drawningAirplane.EntityAirplane() == null)
            return null;
        return new ObjectParameters(_drawningAirplane.GetPosX(), _drawningAirplane.GetPosY(),
                _drawningAirplane.GetWidth(), _drawningAirplane.GetHeight());
    }
    public int GetStep(){
        if(_drawningAirplane.EntityAirplane() == null)
            return 0;
        return (int)_drawningAirplane.EntityAirplane().Step();
    }
    public boolean CheckCanMove(DirectionType direction){
        if(_drawningAirplane == null)
            return false;
        return _drawningAirplane.CanMove(direction);
    }
    public void MoveObject(DirectionType direction){
        if(_drawningAirplane == null)
            return;
        _drawningAirplane.MoveTransport(direction);
    }
}
